#!/usr/bin/perl -I/home/pinson/szpari/programs/Perl/

print STDERR "
                    :-] G R O M A C S [-:
                        helpful tools

                :-] g_disreoutbygdist.pl  [-:

Option     Filename  Type          Description
------------------------------------------------------------
";


use Getopt::Std;

$opt_s="topol.tpr";
$opt_S="";
$opt_f="traj.trr";
$opt_p="topol.top";
$opt_n="index.ndx";
$opt_o="NOE/d";

getopts('p:s:f:o:n:S:hv') || die "ERROR in options, exiting\n";

$nmrfile=$opt_n;
$dihedralfile=$opt_d;
$S2file=$opt_s;

if ($opt_h){$HO="yes"} else{$HO="no"}
if($opt_v){$V=1;$VO="yes"}else{$VO="no"}

printf STDERR ("  -p  %12s   Input         Topology file\n",$opt_p);
printf STDERR ("  -s  %12s   Input         Generic run input (for g_dist)\n",$opt_s);
printf STDERR ("  -f  %12s   Input         Generic trajectory (for g_dist)\n",$opt_f);
printf STDERR ("  -n  %12s   Input         Index with group IDs identical to\n",$opt_n); 
printf STDERR ("                                   atom numbers in topology file (for g_dist)\n");
printf STDERR ("  -o  %12s   Output        Dir & base name for output xvg files\n",$opt_o);


print STDERR"
      Option   Type  Value  Description
------------------------------------------------------
";

printf STDERR ("          -h   bool %6s  Print help info and quit\n",$HO);
printf STDERR ("          -v   bool %9s  Be loud and noisy\n",$VO);
printf STDERR ("          -S   enum %9s  program suffix for g_dist to invoke\n",$opt_S);



if ($opt_h) {
print STDERR "

A program to be used as a fallback when g_disre bails out (e.g. for memory reasons).
This script derives distance restraints from the supplied topology file (section
[ distance_restraints ] is read until the first blank line or other directive) and
invokes g_dist for each atom pair found. Output is put into a separate file for each 
restraint, restraint No. will be appended to the filename. For ambiguous restraints, 
filename will be extended with '_#' with '#' being the running index for each atom pair.
If a filename with a '/' is supplied, the corresponding directory will be deleted and 
recreated. Only one '/' is allowed.

Do not forget to generate an index file containing each atom as a group with group id 
identical to its atom number in the topology file! This usually can be done with invoking
make_ndx, deleting all groups except the one named 'Protein' (this then will have group
ID=0) and issuing the command 'splitat 0'. You can check the correspondence of atom numbers 
and group IDs by listing the groups.

Outputs a shell script to STDOUT that contains the commands for the g_dist runs.

";
exit;
}


print "\#!/bin/csh\n\n";
print "set program_suffix = \"$opt_S\"\n\n";

if ($opt_o =~ /\/.*\//){die "FATAL: Output file name scheme allows only one '\/' character!\n"}
elsif ($opt_o =~ /\//){
    ($dir,$of)=split(/\//,$opt_o);
    if ($dir ne ""){
      print STDERR "Deleting directory $dir" if $V;
      print ("rm -rf $dir\n");
      print ("mkdir $dir\n\n");
      $of=$dir."/".$of;
    }
}
else{$of=$opt_o}



# Reading in topology file for distance restraints

$restraints=0;
open (TOPIN,"$opt_p") || die "FATAL: Topology file $opt_t not found!\n";
$readres=0;
$lastindex=-1;
while(<TOPIN>){
    $line=$_;
    if (($_=~/^\[/) || ($_=~/; Include Position restraint file/) || ($_ =~ /^$/)){$readres=0}
    # Skip comment lines
    elsif ($_=~/^;/){next}
    if ($readres){
        # Get rid of commments
        $_=~s/ *\;.*$//;
        $_=~s/^ +//;
        ($ai,$aj,$t,$index,$t2,$l,$u1,$u2,$fac)=split(/ +/,$_);
        $AI[$restraints]=$ai;
        $AJ[$restraints]=$aj;
        $INDEX[$restraints]=$index;
        if ($index == $lastindex){
          $AMBIG[$restraints]=1;
          $AMBIG[$restraints-1]=1;
        }
        $lastindex=$index;
        $restraints++;
    }
    if ($_=~/^\[ +distance_restraints +\]/){$readres=1}

}

print STDERR "Read $restraints distance restraints from topology file\n" if $V;

$lastindex=-1;
$subndx=1;
for ($n = 0; $n < $restraints; $n++){

       $index=$INDEX[$n];
       $subndx++;
       if ($index != $lastindex){
         $subndx=1;
       }
       $outfile=sprintf("$of%d",$index);
       if ($AMBIG[$n]){
         $outfile.="_$subndx";
       }
       $outfile.=".xvg";

       $ai=$AI[$n];
       $aj=$AJ[$n];

       $lastindex=$index;
#system("g_dist_mpd -f sgci5_full.trr -s sgci5_full.tpr -n index.ndx -o $dfile << HERE 

# Output script to STDOUT
print ("g_dist\$program_suffix -f $opt_f -s $opt_s -n $opt_n -o $outfile << HERE
$ai
$aj 
HERE
");

}


 

close(TOPIN);
