#!/usr/bin/perl

print STDERR "
                    :-] G R O M A C S [-:
                        helpful tools

                   :-] g_xvgaverage.pl  [-:

Option     Filename  Type          Description
------------------------------------------------------------
";


use Getopt::Std;
$opt_f="rmsd.xvg";
$opt_s=-1;
$opt_e=-1;


getopts('f:s:e:hv') || die "ERROR in options, exiting\n";



$outfile=$opt_o;
$columnid=$opt_c;
if ($opt_h){$HO="yes"} else{$HO="no"}
if($opt_v){$V=1;$VO="yes"}else{$VO="no"}


printf STDERR ("  -f  %12s   Input         xvgr/xmgr file\n",$opt_f);
print STDERR"
      Option   Type  Value  Description
------------------------------------------------------
";

printf STDERR ("          -h   bool %9s  Print help info and quit\n",$HO);
printf STDERR ("          -v   bool %9s  Be loud and noisy\n",$VO);
printf STDERR ("          -s   int  %9s  Start time to average from\n",$opt_s);
printf STDERR ("          -e   int  %9s  End time to average to\n",$opt_e);

print STDERR"\n";
if ($opt_h){
print STDERR"
Calculates averages and standard deviations for all data columns in the input xvg file.
Use -s and -e to restrict the time/frame range to average (1st column in the xvg file).
For both -s and -e the value '-1' means no limits.
Output goes to STDOUT.

";
exit;
}


$datarow=0;
# Getting input file name list:
# Can be separated by ':' and may contain wildcards


$datanum=0;
$maxcol=0;
open (IF,"$opt_f") || die ("Fatal error: $infile not found\n");
    while (<IF>){
    chomp;

    next if ($_ =~ /^[\#\@]/); # skip header
    $_=~s/^ +//;
    @c=split(/ +/,$_);
    if (($c[0] >= $opt_s) && (($c[0] <= $opt_e) || ($opt_e == -1))){
	if ($datanum == 0){
	    $fstart=$c[0];
	    $fend=$c[0];
	}
	elsif($c[0] > $fend){$fend=$c[0]}
	$datanum++;

        # Getting data from all columns
	for ($n=1; $n < @c; $n++){
	    if ($c[$n] =~ /[0-9]/){
		$average[$n]+=$c[$n];
	    }
	    else{
		$skipped[$n]++;
		$skipp[$n][$d]=1;
	    }
	    print STDERR "$n : $average[$n]\n" if $V;
	    $data[$datanum][$n]=$c[$n];
	    if (@c > $maxcol){$maxcol = @c}
	}
    }
}
close(IF);


# Average & stdev
for ($n=1; $n < $maxcol; $n++){
    $average[$n]/=$datanum;
    for ($d=0; $d < $datanum; $d ++){
	if (!$skipp[$n][$d]){
	    $std[$n]+=($data[$d][$n]-$average[$n])*($data[$d][$n]-$average[$n]);
	}
    }
    $std[$n]=sqrt($std[$n]/$datanum);
}

# Output to STDOUT
print "Average and standard deviation of columns 2 - $maxcol in file $opt_f\n";
print "Data points used: $fstart - $fend ($datanum points)\n";

for ($n=1; $n < $maxcol; $n++){
    if ($skipped[$n]){
	printf ("Skipped $skipped[$n] non-numeric data point(s) for column %d\n",$n+1);
    }
}

print "AVG";
for ($n=1; $n < $maxcol; $n++){printf ("  %7.3f",$average[$n])}
print "\n";
print "STD";
for ($n=1; $n < $maxcol; $n++){printf ("  %7.3f",$std[$n])}
print "\n";

